//****************************************
//	RTCA^C NbN
//			Copyright by S.Asakura
//****************************************
#include 	<m8c.h>
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"jihou.h"		// 񃋁[`

//*******************************
//		֐vg^Cv錾
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"rtc-inner.h"	// RTCA^C NbN

//*******************************
//		萔 `
//*******************************
unsigned char	mDays[13] = {0,31,28,31,30,31,30,31,31,30,31,30,31};	// e̓
unsigned char	wkDayStr[7][4] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sut"};

//=========================================================

//*******************************
//	short  l
//*******************************
void ito_0u( unsigned char *numStr, unsigned short num, unsigned char keta ) {
	unsigned char  *s;
	unsigned short d;
	unsigned char  n;
	s = numStr;
	d = num   ;
	n = keta  ;

	s += n;
	*s-- = 0x00;
	while( n-- ){			// '0'`'9' 𖄂߂Ă
		*s-- = (unsigned char)(( d % 10 ) + '0');
		d /= 10;
	}
}

//*******************************
//	Counter8_P1 [`i10msj
//	RTC̊ƂȂ^C}
//*******************************
#pragma interrupt_handler Counter8_P1_ISR
void Counter8_P1_ISR(void) {
	extern	unsigned char	ct8_P1_intCount;	// ct8_P1񐔃JEg
	extern	unsigned char	ct8_P1_int1sec;		// ct8_P1PbʒmtO

	if (++ct8_P1_intCount >= 100) {		// Pbo߂
		ct8_P1_intCount = 0;
		ct8_P1_int1sec = 1;			// ct8_P1PbʒmtO Zbg
	} // end if
}

//*******************************
//	RTC  vX^[g
//*******************************
void rtc_inner_Start(void) {
	extern	unsigned char	ct8_P1_intCount;	// ct8_P1񐔃JEg
	extern	unsigned char	ct8_P1_int1sec;		// ct8_P1PbʒmtO

	ct8_P1_int1sec  = 0;			// ct8_P1PbʒmtO  NA
	ct8_P1_intCount = SEC_HOSEI;	// ct8_P1񐔃JEg, LCD\̒xŖ0.1bi߂
	Counter8_P1_WritePeriod(99);	// JEglZbg
	Counter8_P1_Start(); 			// 10kHz  100Hz pJE^
	Counter8_P1_EnableInt();
}

//*******************************
//	RTC  vXgbv
//*******************************
void rtc_inner_Stop(void) {
	extern	unsigned char	ct8_P1_int1sec;		// ct8_P1PbʒmtO

	Counter8_P1_DisableInt();
	ct8_P1_int1sec  = 0;		// ct8_P1PbʒmtO NA
	Counter8_P1_Stop();
}

//*******************************
//	[N̔
//  4Ŋ؂N[NƂ邪Ĉ100Ŋ؂N͕NƂD
//  AC400Ŋ؂N͉[NƂD
//*******************************
unsigned char judgeLeap(unsigned short nen) {
	unsigned char uruu;
	if (  ( ((nen % 4) == 0) && ((nen % 100) != 0) )	// 4Ŋ؂,100Ŋ؂ȂN͉[N
		 || ((nen % 400) == 0) ) {						// 400Ŋ؂N͉[N
		uruu = 1;		// [Nł
	} else {
		uruu = 0;		// [Nł͂Ȃ
	} // end if nen
	return(uruu);
}

//*******************************
//	RTC tCNg
//*******************************
void rtc_inner_incDate(void) {
	extern	unsigned char	date;		// 1-31 days
	extern	unsigned char	wkDay;		// 0-6 (Sunday=0, Saturday=6)
	extern	unsigned char	month;		// 1-12 months
	extern	unsigned short	year;		// 0-9999 year, 4
	extern	unsigned char	leap;		// [NtO , 0=[Nł͂Ȃ , 1=[N
	extern	unsigned char	mDays[13];

	if (++wkDay > 6) {		// j
		wkDay = 0;
	} // end if wkDay
	if (++date > mDays[month]) {	// 
		if ((leap == 1) && (month == 2)) { 	// [N2
			if (date > 29) {	// 
				date  = 1;
				month = 3;
			} // end if date 29
		} else {		// [Nł͂Ȃ  [NłĂ2ł͂Ȃ
			date = 1;
			if (++month > 12) {			// 
				month = 1;
				if (++year > 9999) {	// N
					year = 0;
				} // end if year
				leap = judgeLeap(year);		// [N̔
			} // end if month
		} // end if leap
	} // end if date
}

//*******************************
// RTC 1b
// ̊Ԃ́CZݏ
//*******************************
void rtc_inner_Tick1sec(void) {
	extern	unsigned char	second;		// 0-59 seconds
	extern	unsigned char	minute;		// 0-59 minutes
	extern	unsigned char	hour;		// 0-23 hours

	if (++second >= 60) {	// b
		second = 0;
		if (++minute >= 60) {	// 
			minute = 0;
			if (++hour >= 24) {		// 
				hour = 0;
				rtc_inner_incDate();	// tCNg
			} // end if hour
		} // end if minute
	} // end if second
}

//*******************************
//	RTC t(N(j)) \
//*******************************
void rtc_inner_dispDate(void) {
	extern	unsigned char	date;		// 1-31 days
	extern	unsigned char	wkDay;		// 0-6 (Sunday=0, Saturday=6)
	extern	unsigned char	month;		// 1-12 months
	extern	unsigned short	year;		// 0-9999 year, 4
	extern	unsigned char	wkDayStr[7][4];
	unsigned char dStr[6];
	dStr[5] = 0x00;
	ito_0u(dStr, year, 4);	// N
	print_chr(dStr[0]); 	// 1 Print, \ׁ̈Cprintf͎gȂ
	print_chr(dStr[1]);
	print_chr(dStr[2]);
	print_chr(dStr[3]);
	print_chr('/');
	ito_0u(dStr, (unsigned short)month, 2);		// 
	print_chr(dStr[0]);
	print_chr(dStr[1]);
	print_chr('/');
	ito_0u(dStr, (unsigned short)date, 2);		// 
	print_chr(dStr[0]);
	print_chr(dStr[1]);
	print_chr('(');
	print_chr(wkDayStr[wkDay][0]);				// j
	print_chr(wkDayStr[wkDay][1]);
	print_chr(wkDayStr[wkDay][2]);
	print_chr(')');
}

//*******************************
//	RTC (b) \
//*******************************
void rtc_inner_dispTime(void) {
	extern	unsigned char	second;		// 0-59 seconds
	extern	unsigned char	minute;		// 0-59 minutes
	extern	unsigned char	hour;		// 0-23 hours
	unsigned char dStr[6];
	dStr[5] = 0x00;
	ito_0u(dStr, (unsigned short)hour  , 2);	// 
	print_chr(dStr[0]);		// 1 Print, \ׁ̈Cprintf͎gȂ
	print_chr(dStr[1]);
	print_chr(':');
	ito_0u(dStr, (unsigned short)minute, 2);	// 
	print_chr(dStr[0]);
	print_chr(dStr[1]);
	print_chr(':');
	ito_0u(dStr, (unsigned short)second, 2);	// b
	print_chr(dStr[0]);
	print_chr(dStr[1]);
}

//*******************************
// RTC tiNjjݒ
//	dateStrF"200612166"		// 2006N1216(y)
//	tƗj̑Ή̓`FbNȂ
//*******************************
BOOL rtc_inner_setYMDW(unsigned char *dateStr) {
	extern	unsigned char	date;		// 1-31 days
	extern	unsigned char	wkDay;		// 0-6 (Sunday=0, Saturday=6)
	extern	unsigned char	month;		// 1-12 months
	extern	unsigned short	year;		// 0-9999 year, 4
	extern	unsigned char	leap;		// [NtO , 0=[Nł͂Ȃ , 1=[N
	extern	unsigned char	jAdjStatLCD;	// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	extern	unsigned char	jAdjStatSIO;	// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	unsigned char *strPtr;
	unsigned short nYear;
	unsigned char  nMonth , nDate , nWkDay, nLeap;

	strPtr = dateStr;
	nYear   = (unsigned short)(((*strPtr++) - '0') * 1000);
	nYear  += (unsigned short)(((*strPtr++) - '0') *  100);
	nYear  += (unsigned short)(((*strPtr++) - '0') *   10);
	nYear  += (unsigned short)(((*strPtr++) - '0')       );
	nMonth  = (((*strPtr++) - '0') * 10);
	nMonth += (((*strPtr++) - '0')     );
	nDate   = (((*strPtr++) - '0') * 10);
	nDate  += (((*strPtr++) - '0')     );
	nWkDay  =  ((*strPtr)   - '0');
	nLeap  = judgeLeap(nYear);			// [N̔
	if (((nYear  >= 1) && (nYear   <= 9999)) && 
		((nMonth >= 1) && (nMonth  <=   12)) && 
		((nDate  >= 1) && ( (nDate <= mDays[nMonth]) || (nLeap == 1 && nMonth == 2 && nDate == 29) )) && 
		((nWkDay >= 0) && (nWkDay  <= 6)) ) {
		year  = nYear;
		month = nMonth;
		date  = nDate;
		wkDay = nWkDay;
		leap  = nLeap;
		jAdjStatLCD  = 0;		// ZXe[^X(LCDp), 0=ʏ, 1=Zς
		jAdjStatSIO  = 0;		// ZXe[^X(SIOp), 0=ʏ, 1=Zς
		return(TRUE);
	} else {
		return(FALSE);
	} // end if nYear
}

//*******************************
// RTC ibjݒ
//	timeStrF"102030"		// 102030b
//*******************************
BOOL rtc_inner_setHMS(unsigned char *timeStr) {
	extern	unsigned char	second;		// 0-59 seconds
	extern	unsigned char	minute;		// 0-59 minutes
	extern	unsigned char	hour;		// 0-23 hours
	extern	unsigned char	jAdjStatLCD;	// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	extern	unsigned char	jAdjStatSIO;	// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	unsigned char *strPtr;
	unsigned char  nHour , nMin , nSec;

	strPtr = timeStr;
	nHour = (((*strPtr++) - '0') * 10);
	nHour+= (((*strPtr++) - '0')     );
	nMin  = (((*strPtr++) - '0') * 10);
	nMin += (((*strPtr++) - '0')     );
	nSec  = (((*strPtr++) - '0') * 10);
	nSec += (((*strPtr)   - '0')     );

	if ( (nHour >= 0 && nHour < 24) 
	  && (nMin  >= 0 && nMin  < 60)
	  && (nSec  >= 0 && nSec  < 60) ) {
		rtc_inner_Stop();		// RTC vXgbv
		hour   = nHour;			// 
		minute = nMin;			// 
		second = nSec;			// b
		rtc_inner_Start();		// RTC vX^[g
		jAdjStatLCD  = 0;		// ZXe[^X(LCDp), 0=ʏ, 1=Zς
		jAdjStatSIO  = 0;		// ZXe[^X(SIOp), 0=ʏ, 1=Zς
		return(TRUE);
	} else {
		return(FALSE);
	} // end if
}

//*******************************
//	RTC  t, l ݒ
//*******************************
void rtc_inner_set_InitDateTime(void) {
	unsigned char	dStr[10] = "200801012";		// 2008N0101() 
	unsigned char	tStr[7]  = "000000";		// 000000b

	rtc_inner_setYMDW(dStr);		// RTC tiNjjݒ
	rtc_inner_setHMS(tStr); 		// RTC ibjݒ
}

//********************
// HELP ClockR}h
//********************
void help_Clock(void) {
	UART_1_CPutString(" CD(Date) ; (Date)=YYYYMMDDW");
	UART_1_PutCRLF();			// s(CR,LF)
	UART_1_CPutString(" CT(Time) ; (Time)=HHMMSS");
	UART_1_PutCRLF();			// s(CR,LF)
}

//*******************************
//	ClockR}h('C') 
//*******************************
void cmdBR_RTC(unsigned char *sPtr) {
	unsigned char *strPtr;

	set_prtdev_sio(); 				// \uSIO(UART)ɂ
	strPtr = sPtr;
	strPtr++;
	switch (*strPtr) {
		case 'D' : 		// Date
		case 'd' : 
			if ( rtc_inner_setYMDW(++strPtr) ) {	// tiNjjݒ
				;
			} else {
				msg_InvalCmd();		// \_R}h
				help_Clock();		// HELP ClockR}h
			}
			break;
		case 'T' : 		// Time
		case 't' : 
			if ( rtc_inner_setHMS(++strPtr) ) {		// ibjݒ
				;
			} else {
				msg_InvalCmd();		// \_R}h
				help_Clock();		// HELP ClockR}h
			}
			break;
		case 'H' : 		// Help
		case 'h' : 
			help_Clock();		// HELP ClockR}h
			break;
		default : 
			msg_InvalCmd();		// \_R}h
			help_Clock();		// HELP ClockR}h
			break;
	} // end switch cmd[1]
}

//********************
// RTC 
//********************
void initRTC(void) {
	rtc_inner_Start();					// RTC vX^[g
	rtc_inner_set_InitDateTime();		// RTC t, l ݒ
}

